#! /usr/bin/env python
# -*- Mode: Python -*-
# -*- coding: ascii -*-

"""
RR_BoneUnPin.py Keys pinned bones into their new position/rotations,
removes their constraints, and removes all of the bonepin nulls in the scene.
"""

__author__     = "Ryan Roye"
__date__       = "July 24 2014"
__copyright__  = "Copyright (C) 2014 Tanadrine Studios"
__version__    = "1.0"
__maintainer__ = "Ryan Roye"
__email__      = "ryanroye@gmail.com"
__status__     = "Utility"
__lwver__      = "11"

try:
    import lwsdk
except ImportError:
    raise Exception("The LightWave Python module could not be loaded.")

#SCRIPT

#Key position of all bones and items in the scene

def getName(item):
    return lwsdk.LWItemInfo().name(item)

#Scan all of the bones and get their names
def boneScan(item):
    bone = lwsdk.LWItemInfo().first(lwsdk.LWI_BONE, item)
    while bone:
        print getName(bone)		
	#Place bone-related functions here
	#==================================
	#Check if bone has Left prefix or suffix. If it does...
	#apply same as item constraints to the opposite side
	
	bonevar = getName(bone)
	lwsdk.command("SelectByName " + bonevar)
	lwsdk.command("AddPosition 0 0 0")
	
	#=====================================
        bone = lwsdk.LWItemInfo().next(bone)

#Scan Objects, Lights and Cameras and get their names
#NOTE: This will not operate on objects that are children of other objects. Top level only.
def scanForItems(type):
    item = lwsdk.LWItemInfo().first(type, None)
    while(item):
        print "Found %s" % getName(item)
	print "this is an item"
	
	#Place item-related functions here
	#==================================
	#Check if bone has Left prefix or suffix. If it does...
	#apply same as item constraints to the opposite side	
	
	bonevar = getName(item)
	lwsdk.command("SelectByName " + bonevar)
	lwsdk.command("AddPosition 0 0 0")
	#=====================================
        if type == lwsdk.LWI_OBJECT:
            boneScan(item)
        item = lwsdk.LWItemInfo().next(item)

#Not sure what the hell this does
for type in [lwsdk.LWI_OBJECT, lwsdk.LWI_LIGHT, lwsdk.LWI_CAMERA]:
    scanForItems(type)

lwsdk.command("RefreshNow")

#Gather Items to be changed...
lwsdk.command("AddNull RR_TEMPTARGET")
temptarget = lwsdk.LWInterfaceInfo().selected_items()
lwsdk.command("SelectByPartialName RR_BonePin_")
items = lwsdk.LWInterfaceInfo().selected_items()

while items != temptarget:
	lwsdk.command("ClearSelected 1")
	lwsdk.command("SelectByName RR_TEMPTARGET")
	lwsdk.command("SelectByPartialName RR_BonePin_")
	items = lwsdk.LWInterfaceInfo().selected_items()
	lwsdk.command("RefreshNow")

lwsdk.command("SelectByName RR_TEMPTARGET")
lwsdk.command("ClearSelected 1")

'''
BACKUP COPY


#Key position of all bones and items in the scene
for item in lwsdk.LWInterfaceInfo().selected_items():
	lwsdk.command("SelectItem " + lwsdk.itemid_to_str(item)) #Select items 1 by 1 using "item" as the variable
	lwsdk.command("AddPosition 0 0 0")
	lwsdk.command("RefreshNow")
	
#Gather Items to be changed...
lwsdk.command("AddNull RR_TEMPTARGET")
temptarget = lwsdk.LWInterfaceInfo().selected_items()
lwsdk.command("SelectByPartialName RR_BonePin_")
items = lwsdk.LWInterfaceInfo().selected_items()

while items != temptarget:
	lwsdk.command("ClearSelected 1")
	lwsdk.command("SelectByName RR_TEMPTARGET")
	lwsdk.command("SelectByPartialName RR_BonePin_")
	items = lwsdk.LWInterfaceInfo().selected_items()
	lwsdk.command("RefreshNow")

lwsdk.command("SelectByName RR_TEMPTARGET")
lwsdk.command("ClearSelected 1")
'''

ServerTagInfo = [
                    ( "RR_BoneUnPin", lwsdk.SRVTAG_USERNAME | lwsdk.LANGID_USENGLISH ),
                    ( "RR_BoneUnPin", lwsdk.SRVTAG_BUTTONNAME | lwsdk.LANGID_USENGLISH ),
                    ( "Utilities/Python", lwsdk.SRVTAG_MENU | lwsdk.LANGID_USENGLISH )
                ]